local CrashSkinCheck = CrashAddon.CrashSkinCheck
local StateSetter = CrashAddon.StateSetter

//a whole transformation sequence
local function SuperTransform(player)
	if not CrashSkinCheck(player)
		return
	end
	
	local crashban = player.crashban
	//this sets up the start of the transformation sequence
	if player.powers[pw_super] and not crashban.supertrans
		crashban.transtimer = 2 * TICRATE + TICRATE / 3
		player.powers[pw_super] = 0
		crashban.akulevel = 4
		P_RestoreMusic(player)
		S_FadeOutStopMusic(2 * MUSICRATE + MUSICRATE / 3, player)
	elseif crashban.supertrans and not player.powers[pw_super]
		crashban.supertrans = false
	end
	//this handles the actual transformation sequence
	if crashban.transtimer > 0
		StateSetter(player.mo, S_PLAY_SPRING)
		crashban.transtimer = $ - 1
		A_ForceStop(player.mo, 0)
		player.pflags = $ | PF_FULLSTASIS
		player.powers[pw_super] = 0
	elseif crashban.transtimer == 0
		P_DoSuperTransformation(player, false)
		crashban.supertrans = true
		crashban.transtimer = $ - 1
	end
end

//hooks
addHook("PlayerThink", SuperTransform)