local BoxTallyMode = CrashAddon.BoxTallyMode
local ObjectSpawner = CrashAddon.ObjectSpawner

//this counts how many tvs have spawned on the map
//not counting respawnable tvs and ctf ring tvs for obvious reasons
local TVSpawn = {
	[400] = true,
	[401] = true,
	[402] = true,
	[403] = true,
	[404] = true,
	[405] = true,
	[406] = true,
	[407] = true,
	[408] = true,
	[410] = true,
	[411] = true,
	[412] = true,
	[413] = true,
	[416] = true,
	[418] = true,
	[419] = true,
	[420] = true,
	[421] = true,
	[422] = true
}

local function BoxCounter(mo, mapthing)
	if not BoxTallyMode()
		return
	end
	if CrashAddon.boxtotal < 0
		CrashAddon.boxcount = 0
		CrashAddon.boxtotal = 0
	end
	if TVSpawn[mapthing.type] and CrashAddon.boxtotal >= 0
		CrashAddon.boxcount = $ + 1
		CrashAddon.boxtotal = CrashAddon.boxcount
		mo.crashmapbox = true
		if mo.type == MT_EGGMAN_BOX
			CrashAddon.theresnitro = true
		end
	end
	//this spawns in the nitro detonator and final box in front of the goal post
	if mapthing.type == 501
		local nitroswitch = ObjectSpawner(mo, MT_NITROSTEEL)
		nitroswitch.tracer = mo
		nitroswitch.changepos = 5
		local finalbox = ObjectSpawner(mo, MT_BLANKBOX)
		finalbox.tracer = mo
		finalbox.changepos = 3
		finalbox.rewardbox = true
		CrashAddon.isvalidlevel = true
	end
	//this sets up deletion of all the emerald tokens in the level
	if mapthing.type == 312
		mo.crashmaptoken = true
	end
end

//hooks
addHook("MapThingSpawn", BoxCounter)
//this resets the count when the map changes
addHook("MapChange", function(mapnum)
	CrashAddon.boxcount = -1
	CrashAddon.boxtotal = -1
	CrashAddon.theresnitro = false
	CrashAddon.nitrodetonator = -1
	CrashAddon.isvalidlevel = false
end)