local BoxTallyMode = CrashAddon.BoxTallyMode

local function BoxTallyHUD(v, player, cam)
	if BoxTallyMode() and CrashAddon.boxtotal > 0 and CrashAddon.isvalidlevel
		//shows how many boxes have been broken vs how many there are total
		local sflags = V_MONOSPACE|V_SNAPTORIGHT|V_ALLOWLOWERCASE
		if CrashAddon.boxcount > 0
			sflags = $ | V_ORANGEMAP
		end
		v.drawString(300, 5, "Boxes: " + (CrashAddon.boxtotal - 
				CrashAddon.boxcount) + "/" + CrashAddon.boxtotal, sflags, 
				"right")
		//if box pointer is enabled, show distance of closest box
		if CrashAddon.globalpointer and player.crash_boxpointer and
				player.crash_boxcompass and player.crash_boxcompass.valid
			local dist = player.crash_boxcompass.closedist / FRACUNIT
			local hflags = V_MONOSPACE|V_SNAPTORIGHT|V_ALLOWLOWERCASE
			if dist <= 1000
				hflags = $ | V_REDMAP
			elseif dist <= 3000
				hflags = $ | V_YELLOWMAP
			elseif dist <= 7500
				hflags = $ | V_GREENMAP
			else
				hflags = $ | V_GRAYMAP
			end
			v.drawString(300, 20, "Closest: " + dist + "m", hflags, "right")
		end
	end
end
hud.add(BoxTallyHUD, "game")